// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _Vtop_H_
#define _Vtop_H_

#include "verilated.h"
#include "SpCoverage.h"
#include "Vtop__Inlines.h"
class Vtop__Syms;

//----------

VL_MODULE(Vtop) {
  public:
    // CELLS
    // Public to allow access to /*verilator_public*/ items;
    // otherwise the application code can consider these internals.
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk_i,0,0);
    VL_IN8(rst_i,0,0);
    VL_IN8(iwb_clk_i,0,0);
    VL_IN8(iwb_rst_i,0,0);
    VL_IN8(dwb_clk_i,0,0);
    VL_IN8(dwb_rst_i,0,0);
    VL_IN8(clmode_i,1,0);
    VL_IN8(iwb_ack_i,0,0);
    VL_IN8(iwb_err_i,0,0);
    VL_IN8(iwb_rty_i,0,0);
    VL_OUT8(iwb_cyc_o,0,0);
    VL_OUT8(iwb_stb_o,0,0);
    VL_OUT8(iwb_we_o,0,0);
    VL_OUT8(iwb_sel_o,3,0);
    VL_OUT8(iwb_cab_o,0,0);
    VL_IN8(dwb_ack_i,0,0);
    VL_IN8(dwb_err_i,0,0);
    VL_IN8(dwb_rty_i,0,0);
    VL_OUT8(dwb_cyc_o,0,0);
    VL_OUT8(dwb_stb_o,0,0);
    VL_OUT8(dwb_we_o,0,0);
    VL_OUT8(dwb_sel_o,3,0);
    VL_OUT8(dwb_cab_o,0,0);
    VL_IN8(dbg_stall_i,0,0);
    VL_IN8(dbg_ewt_i,0,0);
    VL_OUT8(dbg_lss_o,3,0);
    VL_OUT8(dbg_is_o,1,0);
    VL_OUT8(dbg_bp_o,0,0);
    VL_IN8(dbg_stb_i,0,0);
    VL_IN8(dbg_we_i,0,0);
    VL_OUT8(dbg_ack_o,0,0);
    VL_IN8(pm_cpustall_i,0,0);
    VL_OUT8(pm_clksd_o,3,0);
    VL_OUT8(pm_dc_gate_o,0,0);
    VL_OUT8(pm_ic_gate_o,0,0);
    VL_OUT8(pm_dmmu_gate_o,0,0);
    VL_OUT8(pm_immu_gate_o,0,0);
    VL_OUT8(pm_tt_gate_o,0,0);
    VL_OUT8(pm_cpu_gate_o,0,0);
    VL_OUT8(pm_wakeup_o,0,0);
    VL_OUT8(pm_lvolt_o,0,0);
    //char	__VpadToAlign41[1];
    VL_OUT16(dbg_wp_o,10,0);
    VL_IN(pic_ints_i,19,0);
    VL_IN(iwb_dat_i,31,0);
    VL_OUT(iwb_adr_o,31,0);
    VL_OUT(iwb_dat_o,31,0);
    VL_IN(dwb_dat_i,31,0);
    VL_OUT(dwb_adr_o,31,0);
    VL_OUT(dwb_dat_o,31,0);
    VL_IN(dbg_adr_i,31,0);
    VL_IN(dbg_dat_i,31,0);
    VL_OUT(dbg_dat_o,31,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    VL_SIG8(v__DOT__dcsb_cyc_dc,0,0);
    VL_SIG8(v__DOT__dcsb_stb_dc,0,0);
    VL_SIG8(v__DOT__dcsb_cab_dc,0,0);
    VL_SIG8(v__DOT__sbbiu_ack_biu,0,0);
    VL_SIG8(v__DOT__sbbiu_err_biu,0,0);
    VL_SIG8(v__DOT__icbiu_cyc_ic,0,0);
    VL_SIG8(v__DOT__icbiu_stb_ic,0,0);
    VL_SIG8(v__DOT__icbiu_cab_ic,0,0);
    VL_SIG8(v__DOT__icbiu_ack_biu,0,0);
    VL_SIG8(v__DOT__icbiu_err_biu,0,0);
    VL_SIG8(v__DOT__spr_we,0,0);
    VL_SIG8(v__DOT__qmemdmmu_err_qmem,0,0);
    VL_SIG8(v__DOT__qmemdmmu_tag_qmem,3,0);
    VL_SIG8(v__DOT__dcpu_cycstb_cpu,0,0);
    VL_SIG8(v__DOT__dcpu_sel_cpu,3,0);
    VL_SIG8(v__DOT__dcpu_ack_qmem,0,0);
    VL_SIG8(v__DOT__icpu_ack_qmem,0,0);
    VL_SIG8(v__DOT__qmemimmu_rty_qmem,0,0);
    VL_SIG8(v__DOT__qmemimmu_err_qmem,0,0);
    VL_SIG8(v__DOT__qmemimmu_tag_qmem,3,0);
    VL_SIG8(v__DOT__qmemimmu_cycstb_immu,0,0);
    VL_SIG8(v__DOT__icqmem_err_ic,0,0);
    VL_SIG8(v__DOT__icqmem_cycstb_qmem,0,0);
    VL_SIG8(v__DOT__icqmem_ack_ic,0,0);
    VL_SIG8(v__DOT__dcqmem_err_dc,0,0);
    VL_SIG8(v__DOT__dcqmem_cycstb_qmem,0,0);
    VL_SIG8(v__DOT__dcqmem_ci_qmem,0,0);
    VL_SIG8(v__DOT__dcqmem_we_qmem,0,0);
    VL_SIG8(v__DOT__dcqmem_sel_qmem,3,0);
    VL_SIG8(v__DOT__dcqmem_ack_dc,0,0);
    VL_SIG8(v__DOT__du_read,0,0);
    VL_SIG8(v__DOT__du_write,0,0);
    VL_SIG8(v__DOT__branch_op,2,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__valid_div,1,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__aborted,0,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__aborted_r,0,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__previous_complete,0,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__repeated_access,0,0);
    VL_SIG8(v__DOT__iwb_biu__DOT__repeated_access_ack,0,0);
    VL_SIG8(v__DOT__dwb_biu__DOT__valid_div,1,0);
    VL_SIG8(v__DOT__dwb_biu__DOT__aborted,0,0);
    VL_SIG8(v__DOT__dwb_biu__DOT__aborted_r,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__icfsm_biu_read,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__tagcomp_miss,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__icfsm_first_miss_ack,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__state,1,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__cnt,2,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__hitmiss_eval,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__load,0,0);
    VL_SIG8(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__cache_inhibit,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__rf_addrw,4,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__alu_op,3,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__shrot_op,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__comp_op,3,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__lsu_op,3,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__genpc_freeze,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__if_freeze,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__id_freeze,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__wb_freeze,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__sel_a,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__sel_b,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__rfwb_op,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__wbforw_valid,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__multicycle,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_type,3,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__flushpipe,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__extend_flush,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__branch_taken,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__flagforw,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__flag_we,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__cyforw,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__cy_we,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__lsu_stall,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__pc_we,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__sr_we,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_start,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__sig_syscall,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__sig_trap,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__no_more_dslot,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__if_stall,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__id_macrc_op,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__ex_macrc_op,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__mac_op,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__mac_stall,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__genpc_refetch,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_align,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_dtlbmiss,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_dmmufault,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_illegal,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__except_dbuserr,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_if__DOT__saved,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_ctrl__DOT__pre_branch_op,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_ctrl__DOT__wb_rfaddrw,4,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_ctrl__DOT__sel_imm,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_ctrl__DOT__imm_signextend,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_addrw,4,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__spr_valid,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_we_allow,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_a__DOT__intaddr_a,4,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_a__DOT__intaddr_b,4,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_operandmuxes__DOT__saved_a,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_operandmuxes__DOT__saved_b,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__flagcomp,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__mac_op_r1,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__mac_op_r2,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__mac_op_r3,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__div_free,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__write_spr,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__read_spr,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__npc_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__ppc_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__sr_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__epcr_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__eear_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__esr_sel,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__sprs_op,3,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_lsu__DOT__or1200_reg2mem__DOT__memdata_hh,7,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_lsu__DOT__or1200_reg2mem__DOT__memdata_hl,7,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_lsu__DOT__or1200_reg2mem__DOT__memdata_lh,7,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_freeze__DOT__multicycle_cnt,1,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_freeze__DOT__flushpipe_r,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__id_exceptflags,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__ex_exceptflags,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__state,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__ex_dslot,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__except_flushpipe,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__delayed_iee,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__delayed_tee,2,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__int_pending,0,0);
    VL_SIG8(v__DOT__or1200_cpu__DOT__or1200_except__DOT__tick_pending,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__dcfsm_biu_read,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__tagcomp_miss,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__dcfsm_first_miss_ack,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__state,2,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__cnt,2,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__hitmiss_eval,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__store,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__load,0,0);
    VL_SIG8(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__cache_inhibit,0,0);
    VL_SIG8(v__DOT__or1200_qmem_top__DOT__state,2,0);
    VL_SIG8(v__DOT__or1200_qmem_top__DOT__qmem_dack,0,0);
    VL_SIG8(v__DOT__or1200_qmem_top__DOT__qmem_iack,0,0);
    VL_SIG8(v__DOT__or1200_qmem_top__DOT__qmem_en,0,0);
    VL_SIG8(v__DOT__or1200_du__DOT__dbg_bp_r,0,0);
    VL_SIG8(v__DOT__or1200_tt__DOT__match,0,0);
    VL_SIG8(v__DOT__or1200_pm__DOT__sdf,3,0);
    VL_SIG8(v__DOT__or1200_pm__DOT__dme,0,0);
    VL_SIG8(v__DOT__or1200_pm__DOT__sme,0,0);
    VL_SIG8(v__DOT__or1200_pm__DOT__dcge,0,0);
    //char	__VpadToAlign237[1];
    VL_SIG16(v__DOT__or1200_cpu__DOT__esr,15,0);
    VL_SIG16(v__DOT__or1200_cpu__DOT__to_sr,15,0);
    VL_SIG16(v__DOT__or1200_cpu__DOT__sr,15,0);
    VL_SIG16(v__DOT__or1200_cpu__DOT__spr_addrimm,15,0);
    VL_SIG16(v__DOT__or1200_cpu__DOT__or1200_except__DOT__except_trig,12,0);
    VL_SIG16(v__DOT__or1200_qmem_top__DOT__or1200_qmem_ram__DOT__addr_reg,10,0);
    VL_SIG16(v__DOT__or1200_du__DOT__dsr,13,0);
    VL_SIG16(v__DOT__or1200_du__DOT__drr,13,0);
    VL_SIG16(v__DOT__or1200_du__DOT__except_stop,13,0);
    VL_SIG(v__DOT__spr_addr,31,0);
    VL_SIG(v__DOT__spr_dat_cpu,31,0);
    VL_SIG(v__DOT__spr_cs,31,0);
    VL_SIG(v__DOT__dcpu_adr_cpu,31,0);
    VL_SIG(v__DOT__dcpu_dat_cpu,31,0);
    VL_SIG(v__DOT__dcpu_dat_qmem,31,0);
    VL_SIG(v__DOT__icpu_adr_cpu,31,0);
    VL_SIG(v__DOT__icpu_dat_qmem,31,0);
    VL_SIG(v__DOT__icpu_adr_immu,31,0);
    VL_SIG(v__DOT__icqmem_adr_qmem,31,0);
    VL_SIG(v__DOT__dcqmem_adr_qmem,31,0);
    VL_SIG(v__DOT__dcqmem_dat_qmem,31,0);
    VL_SIG(v__DOT__spr_dat_pic,31,0);
    VL_SIG(v__DOT__spr_dat_pm,31,0);
    VL_SIG(v__DOT__spr_dat_tt,31,0);
    VL_SIG(v__DOT__spr_dat_du,31,0);
    VL_SIG(v__DOT__ex_insn,31,0);
    VL_SIG(v__DOT__id_pc,31,0);
    VL_SIG(v__DOT__rf_dataw,31,0);
    VL_SIG(v__DOT__iwb_biu__DOT__wb_dat_r,31,0);
    VL_SIG(v__DOT__or1200_immu_top__DOT__icpu_vpn_r,31,13);
    VL_SIG(v__DOT__or1200_ic_top__DOT__ic_addr,31,0);
    VL_SIG(v__DOT__or1200_ic_top__DOT__or1200_ic_fsm__DOT__saved_addr_r,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__if_insn,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__branch_addrofs,31,2);
    VL_SIG(v__DOT__or1200_cpu__DOT__muxed_b,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__wb_forw,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__operand_a,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__operand_b,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__alu_dataout,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__lsu_dataout,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__sprs_dataout,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__lsu_addrofs,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__epcr,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__eear,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__spr_dat_cfgr,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__mult_mac_result,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_genpc__DOT__pcreg,31,2);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_genpc__DOT__pc,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_if__DOT__insn_saved,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_if__DOT__addr_saved,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_ctrl__DOT__id_insn,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__from_rfa,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__from_rfb,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_dataw,31,0);
    //char	__VpadToAlign436[4];
    VL_SIGW(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__rf_a__DOT__mem,1023,0,32);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_operandmuxes__DOT__muxed_a,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__shifted_rotated,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__result_cust5,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__comp_a,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__comp_b,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_alu__DOT__result_and,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__unqualified_cs,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_lsu__DOT__or1200_mem2reg__DOT__aligned,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_except__DOT__ex_pc,31,0);
    VL_SIG(v__DOT__or1200_cpu__DOT__or1200_except__DOT__wb_pc,31,0);
    VL_SIG(v__DOT__or1200_dc_top__DOT__dc_addr,31,0);
    VL_SIG(v__DOT__or1200_dc_top__DOT__or1200_dc_fsm__DOT__saved_addr_r,31,0);
    VL_SIG(v__DOT__or1200_qmem_top__DOT__qmem_do,31,0);
    VL_SIG(v__DOT__or1200_qmem_top__DOT__qmem_addr,31,0);
    VL_SIG(v__DOT__or1200_du__DOT__dmr1,24,0);
    VL_SIG(v__DOT__or1200_pic__DOT__picmr,19,2);
    VL_SIG(v__DOT__or1200_pic__DOT__picsr,19,0);
    VL_SIG(v__DOT__or1200_pic__DOT__um_ints,19,0);
    VL_SIG(v__DOT__or1200_tt__DOT__ttmr,31,0);
    VL_SIG(v__DOT__or1200_tt__DOT__ttcr,31,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__dataa_saved,32,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_rf__DOT__datab_saved,32,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__mul_prod_r,63,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__mac_r,63,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__or1200_gmultp2_32x32__DOT__p0,63,0);
    VL_SIG64(v__DOT__or1200_cpu__DOT__or1200_mult_mac__DOT__or1200_gmultp2_32x32__DOT__p1,63,0);
    VL_SIG(v__DOT__or1200_qmem_top__DOT__or1200_qmem_ram__DOT__mem[2048],31,0);
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    VL_SIG8(__Vclklast__TOP__dwb_clk_i,0,0);
    VL_SIG8(__Vclklast__TOP__dwb_rst_i,0,0);
    VL_SIG8(__Vclklast__TOP__iwb_clk_i,0,0);
    VL_SIG8(__Vclklast__TOP__iwb_rst_i,0,0);
    VL_SIG8(__Vclklast__TOP__clk_i,0,0);
    VL_SIG8(__Vclklast__TOP__rst_i,0,0);
    VL_SIG8(__Vchglast__TOP__v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__write_spr,0,0);
    VL_SIG8(__Vchglast__TOP__v__DOT__or1200_cpu__DOT__or1200_sprs__DOT__read_spr,0,0);
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    Vtop__Syms*	__VlSymsp;		// Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
	const char* hierp, const char* pagep, const char* commentp);
    
    // PARAMETERS
    // Parameters marked /*verilator public*/ for use by application code
  public:
    
    // CONSTRUCTORS
  private:
    Vtop& operator= (const Vtop&);	///< Copying not allowed
    Vtop(const Vtop&);	///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible WRT DPI scope names.
    Vtop(const char* name="TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vtop();
    
    // USER METHODS
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vtop__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vtop__Syms* symsp, bool first);
  private:
    static IData	_change_request(Vtop__Syms* __restrict vlSymsp);
  public:
    static void	_combo__TOP__12(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__15(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__17(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__19(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__21(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__23(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__5(Vtop__Syms* __restrict vlSymsp);
    static void	_combo__TOP__9(Vtop__Syms* __restrict vlSymsp);
    static void	_eval(Vtop__Syms* __restrict vlSymsp);
    static void	_eval_initial(Vtop__Syms* __restrict vlSymsp);
    static void	_eval_settle(Vtop__Syms* __restrict vlSymsp);
    static void	_initial__TOP(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__11(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__14(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__2(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__3(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__4(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__6(Vtop__Syms* __restrict vlSymsp);
    static void	_sequent__TOP__8(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__1(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__10(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__13(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__16(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__18(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__20(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__22(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__24(Vtop__Syms* __restrict vlSymsp);
    static void	_settle__TOP__7(Vtop__Syms* __restrict vlSymsp);
} VL_ATTR_ALIGNED(64);

#endif  /*guard*/
